﻿Imports System.Threading
Imports ProgressBar.Framework

Namespace ProgressBar.Controllers
	Public Class TaskController
		Inherits ProgressBarController
		Public Function DoWork(ByVal repeat As Int32) As String
			Dim taskId = GetTaskId()
			For i = 1 To repeat
				ProgressManager.SetCompleted(taskId, String.Format("Iteration #{0} completed...", i))
				Thread.Sleep(2000)

				If ProgressManager.ShouldTerminate(taskId) Then
					' Compensate here
					' 

					' Update status
					Dim status = String.Format("Task aborted: {0}/{1} step(s) completed.", i, repeat)
					ProgressManager.SetCompleted(taskId, status)

					' Return
					Return status
				End If
			Next i

			' Some return value
			Return String.Format("Task completed @{0}", Date.Now.ToString("h:mm:ss"))
		End Function

		Public Function BookFlight(ByVal [from] As String, ByVal [to] As String) As String
			Dim taskId = GetTaskId()

			' Book first leg
			ProgressManager.SetCompleted(taskId, "{2} || Booking flight: {0}-{1} ...", [from], [to], taskId)
			Thread.Sleep(2000)
			If ProgressManager.ShouldTerminate(taskId) Then
				' Compensate here
				' 
				Return String.Format("One flight booked and then canceled")
			End If

			' Book return 
			ProgressManager.SetCompleted(taskId, "{2} || Booking flight: {0}-{1} ...", [to], [from], taskId)
			Thread.Sleep(3000)
			If ProgressManager.ShouldTerminate(taskId) Then
				' Compensate here
				' 
				Return String.Format("Two flights booked and then canceled")
			End If

			' Book return 
			ProgressManager.SetCompleted(taskId, "{0} || Paying for the flight ...", taskId)
			Thread.Sleep(2000)
			If ProgressManager.ShouldTerminate(taskId) Then
				' Compensate here
				' 
				Return String.Format("Payment canceled. No flights booked.")
			End If

			' Some return value
			Return String.Format("{0} || Flight booked successfully", taskId)
		End Function
	End Class
End Namespace
