Imports System.Web.Caching
Imports ProgressBar.Framework.Abstractions

Namespace ProgressBar.Framework
	Public Class AspnetProgressProvider
		Implements IProgressDataProvider
		Private _durationInSeconds As Int32 = 5
		Public Sub [Set](ByVal taskId As String, ByVal progress As String, Optional ByVal durationInSeconds As Int32 =5) Implements IProgressDataProvider.Set
			_durationInSeconds = durationInSeconds

			HttpContext.Current.Cache.Insert(taskId, New TaskStatus(progress), Nothing, Date.Now.AddSeconds(_durationInSeconds), Cache.NoSlidingExpiration)
		End Sub

		Public Function [Get](ByVal taskId As String) As String Implements IProgressDataProvider.Get
			Dim taskStatus = TryCast(HttpContext.Current.Cache(taskId), TaskStatus)
			Return If(taskStatus Is Nothing, String.Empty, taskStatus.Status)
		End Function

		Public Sub Abort(ByVal taskId As String) Implements IProgressDataProvider.Abort
			HttpContext.Current.Cache.Insert(taskId, New TaskStatus(String.Empty, True), Nothing, Date.Now.AddSeconds(_durationInSeconds), Cache.NoSlidingExpiration)
		End Sub

		Public Function ShouldTerminate(ByVal taskId As String) As Boolean Implements IProgressDataProvider.ShouldTerminate
			Dim taskStatus = TryCast(HttpContext.Current.Cache(taskId), TaskStatus)
			Return If(taskStatus Is Nothing, False, taskStatus.Aborted)
		End Function
	End Class
End Namespace